// cDrawWin.cpp : implementation file
//

#include "stdafx.h"
#include "cDrawWin.h"


// cDrawWin

IMPLEMENT_DYNAMIC(cDrawWin, CWnd)

//------------------------------------------------------------------

cDrawWin::cDrawWin()
{
}

//------------------------------------------------------------------

cDrawWin::~cDrawWin()
{
}


//------------------------------------------------------------------

BEGIN_MESSAGE_MAP(cDrawWin, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
END_MESSAGE_MAP()

//------------------------------------------------------------------

void  cDrawWin::myCreate(CWnd *parent,CRect rect0,
		DrawFuncType *draw0)
{
	rect=rect0;

   int r=Create(NULL, NULL, WS_CHILD | WS_VISIBLE|SS_WHITEFRAME,
       rect, parent, 1234);

   draw=draw0;
}

//------------------------------------------------------------------


//----------------------------------------------
//----------------------------------------------


int cDrawWin::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here
	
    CClientDC dc(this) ;
	//
	// Fill in the Pixel Format Descriptor
	//
    PIXELFORMATDESCRIPTOR pfd ;
	memset(&pfd,0, sizeof(PIXELFORMATDESCRIPTOR)) ;

    pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR);   
    pfd.nVersion = 1 ;                           // Version number
	pfd.dwFlags =  PFD_DOUBLEBUFFER |            // Use double buffer
	               PFD_SUPPORT_OPENGL |          // Use OpenGL
	               PFD_DRAW_TO_WINDOW ;          // Pixel format is for a window.
	pfd.iPixelType = PFD_TYPE_RGBA ;
    pfd.cColorBits = 24;                         // 8-bit color
	pfd.cDepthBits = 32 ;					   	 // 32-bit depth buffer
    pfd.iLayerType = PFD_MAIN_PLANE ;            // Layer type

    int nPixelFormat = ChoosePixelFormat(dc.m_hDC, &pfd);
	if (nPixelFormat == 0)
	{
		TRACE("ChoosePixelFormat Failed %d\r\n",GetLastError()) ;
		return -1 ;
	}
	TRACE("Pixel Format %d\r\n", nPixelFormat) ;

    BOOL bResult = SetPixelFormat(dc.m_hDC, nPixelFormat, &pfd);
	if (!bResult)
	{
		TRACE("SetPixelFormat Failed %d\r\n",GetLastError()) ;
		return -1 ;
	}
	
	//
    // Create a rendering context.
    //
    m_hrc = wglCreateContext(dc.m_hDC);
	if (!m_hrc)
	{
		TRACE("wglCreateContext Failed %x\r\n", GetLastError()) ;
		return -1;
	}


	// Make the rendering context m_hrc current
	
    bResult = wglMakeCurrent(dc.m_hDC, m_hrc);
	if (!bResult)
	{
		TRACE("wglMakeCurrent Failed %x\r\n", GetLastError() ) ;
		return -1;
	}

	// No rendering context will be current.
	
    wglMakeCurrent(NULL, NULL);


	return 0;
}

//------------------------------------------------------------------

void cDrawWin::OnDestroy()
{
	CWnd::OnDestroy();

	wglMakeCurrent(NULL,NULL) ; 
	if (m_hrc) 
	{
		wglDeleteContext(m_hrc) ;
		m_hrc = NULL ;
	}		
}

//------------------------------------------------------------------


//------------------------------------------------------------------

void cDrawWin::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CWnd::OnPaint() for painting messages

	// Make the HGLRC current
    BOOL bResult = wglMakeCurrent(dc.m_hDC, m_hrc);
	if (!bResult)
	{
		TRACE("wglMakeCurrent Failed %x\r\n", GetLastError() ) ;
	}

	// sauvegarder l'tat de la machine OpenGL
	glPushAttrib(GL_ALL_ATTRIB_BITS );

	draw(rect.Width(),rect.Height());

	SwapBuffers(dc.m_hDC) ;

	glPopAttrib( );

	wglMakeCurrent(NULL, NULL) ;
}

//------------------------------------------------------------------

BOOL cDrawWin::PreCreateWindow(CREATESTRUCT& cs)
{
	// pour OpenGL
  	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN; 

	return CWnd::PreCreateWindow(cs);
}

//------------------------------------------------------------------

void OutputGlError(char* label) 
{
	GLenum errorno = glGetError() ;
	if (errorno != GL_NO_ERROR)
		TRACE("%s had error: #(%d) %s\r\n", label, errorno, gluErrorString(errorno)) ;
}

//------------------------------------------------------------------

