// cubeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "cube.h"
#include "cubeDlg.h"

#include "direct.h"

#include "draw.h"
#include ".\cubedlg.h"

//--------------------------------------------------------------
// on passe le dialogue  la fonction draw (draw.cpp)
cDiaProprietes *theDiaProp; // dialogue de proprits

//--------------------------------------------------------------

CCubeDlg::CCubeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCubeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCubeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//--------------------------------------------------------------

void CCubeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCubeDlg)
	DDX_Control(pDX, IDC_SCROLLBARouverture, m_sbOuverture);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_SCROLLBAR1, m_sbRotX);
	DDX_Control(pDX, IDC_SCROLLBAR3, m_sbRotY);
	DDX_Control(pDX, IDC_SCROLLBAR4, m_sbRotZ);
	DDX_Control(pDX, IDC_SCROLLBAR2, m_sbTransX);
	DDX_Control(pDX, IDC_SCROLLBAR5, m_sbTransY);
	DDX_Control(pDX, IDC_SCROLLBAR6, m_sbTransZ);
}

BEGIN_MESSAGE_MAP(CCubeDlg, CDialog)
	//{{AFX_MSG_MAP(CCubeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
	ON_WM_CONTEXTMENU()
	ON_WM_KEYUP()
	ON_COMMAND(ID_OBJETSPR_ROBOT, OnObjetsprRobot)
	ON_COMMAND(ID_OBJETSPR_SAVESCROLLBARS, OnObjetsprSavescrollbars)
	ON_COMMAND(ID_OBJETSPR_LOADSCROLLBARS, OnObjetsprLoadscrollbars)
	ON_COMMAND(ID_OBJETSPR_INITIALISERLAPOSITIONDELASC, OnObjetsprInitialiserlapositiondelasc)
//	ON_WM_TIMER()
END_MESSAGE_MAP()


//--------------------------------------------------------------

void CCubeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//--------------------------------------------------------------

HCURSOR CCubeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//--------------------------------------------------------------
//--------------------------------------------------------------

BOOL CCubeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	theDiaProp=&diaProp;

	CRect rd,rr;
	GetClientRect(&rd);
	m_sbRotX.GetWindowRect(rr);
	rd.bottom=rr.top-55;
	
	m_graphe.myCreate(this,&rd,draw);
	
//----------------------------------

	m_sbOuverture.setSB(0,85,&ouverture,1,10);

	m_sbRotX.setSB(-90,90,&angleX,1,10);
	m_sbRotY.setSB(-180,180,&angleY,1,10);
	m_sbRotZ.setSB(-90,90,&angleZ,1,10);

	m_sbTransX.setSB(-200,200,&transX,1,10);
	m_sbTransY.setSB(-200,200,&transY,1,10);
	m_sbTransZ.setSB(-600,100,&transZ,1,10);
	
// mettre en commentaire au dbut
	/*loadScrollBars(
		"D:\\Cours\SIF1032\\programmesSIF1032\\programmes\\ch4\\ch4.2\\monTriangle\\xx.scrollBar");
		
	*/

	return TRUE;  // return TRUE  unless you set the focus to a control
}

//--------------------------------------------------------------

void CCubeDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	cMaHScroll* sb=(cMaHScroll*)pScrollBar;

	sb->onScroll(nSBCode,nPos);
	m_graphe.Invalidate();

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

//--------------------------------------------------------------


void CCubeDlg::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	CMenu menu;
	menu.LoadMenu(IDR_MENUobjets);

	menu.GetSubMenu(0)
		->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,
		point.x, point.y,this);	
}

//--------------------------------------------------------------

/*
nChar 
Specifies the virtual key code of the given key. 
For a list of of standard virtual key codes, see Winuser.h 


*/


void CCubeDlg::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// les fleches: VK_UP, VK_LEFT ...
	// ici on bouge le frontClipPlane

	float del=5;

	if(nChar==VK_HOME)
	{
		//theCamera->frontClipPlane+=del;
		m_graphe.Invalidate();
	}
	if(nChar==VK_END)
	{
		//theCamera->frontClipPlane-=del;
		m_graphe.Invalidate();
	}

	CDialog::OnKeyUp(nChar, nRepCnt, nFlags);
}

//--------------------------------------------------------------
//--------------------------------------------------------------


void CCubeDlg::OnObjetsprRobot()
{
	diaProp.DoModal();

	m_graphe.Invalidate();
}

//--------------------------------------------------------------

void CCubeDlg::OnObjetsprSavescrollbars()
{
	char buf[500];
	_getcwd(buf,500);
	CString pn=buf;
	pn+="\\xx.scrollBar";

	CFileDialog dia(FALSE,"*.scrollBar",pn,0,"Log scroll bar|*.scrollBar||");


	dia.DoModal();
	CString fn=dia.GetPathName();
	saveScrollBars(fn);
}

//--------------------------------------------------------------

void CCubeDlg::OnObjetsprLoadscrollbars()
{
	char buf[500];
	_getcwd(buf,500);
	CString pn=buf;
	pn+="\\xx.scrollBar";

	CFileDialog dia(TRUE,"*.scrollBar",pn,0,"Log scroll bar|*.scrollBar||");


	dia.DoModal();
	CString fn=dia.GetPathName();
	loadScrollBars(fn);

}
//-------------------------------------------------
	
void CCubeDlg::saveScrollBars(const char*fn)
	{
		FILE *fp;
		fp=fopen(fn,"w");
		if(fp==NULL)
		{
			CString mes("erreur fopen, saveFile: ");

			AfxMessageBox(mes+fn);
			exit(333);
		}
	m_sbOuverture.save(fp);
	
	m_sbRotX.save(fp);
	m_sbRotY.save(fp);
	m_sbRotZ.save(fp);

	m_sbTransX.save(fp);
	m_sbTransY.save(fp);
	m_sbTransZ.save(fp);


		fclose(fp);
	}

//-------------------------------------------------

	
//-------------------------------------------------

void CCubeDlg::loadScrollBars(const char* fn)
{
		FILE *fp;
		fp=fopen(fn,"r");
		if(fp==NULL)
		{
			CString mes("erreur fopen, loadFile: ");

			AfxMessageBox(mes+fn);
			exit(334);
		}

	m_sbOuverture.load(fp);
	m_sbRotX.load(fp);
	m_sbRotY.load(fp);
	m_sbRotZ.load(fp);

	m_sbTransX.load(fp);
	m_sbTransY.load(fp);
	m_sbTransZ.load(fp);

		fclose(fp);
	Invalidate();

	}


//-------------------------------------------------


void CCubeDlg::OnObjetsprInitialiserlapositiondelasc()
{
	angleX=angleY=angleZ=transX=transY=0;
	transZ=-300;
	ouverture=40;
	m_sbOuverture.setPosition(ouverture);
	m_sbRotX.setPosition(angleX );;
	m_sbRotY.setPosition(angleY );;
	m_sbRotZ.setPosition(angleZ );;

	m_sbTransX.setPosition(transX );;
	m_sbTransY.setPosition(transY );;
	m_sbTransZ.setPosition(transZ);;

	Invalidate();
}

//BOOL CCubeDlg::DestroyWindow()
//{
//	// TODO : ajoutez ici votre code spcialis et/ou l'appel de la classe de base
//
//	KillTimer(1);
//
//	return CDialog::DestroyWindow();
//}

//void CCubeDlg::OnTimer(UINT nIDEvent)
//{
//	// TODO : ajoutez ici le code de votre gestionnaire de messages et/ou les paramtres par dfaut des appels
//	angleY+=5;
//	m_graphe.Invalidate();
//	m_graphe2.Invalidate();
//	CDialog::OnTimer(nIDEvent);
//}
